/*
 * Copyright 2008 Sony Corporation of America
 *
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this Library and associated documentation files (the
 * "Library"), to deal in the Library without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Library, and to
 * permit persons to whom the Library is furnished to do so, subject to
 * the following conditions:
 *
 *  The above copyright notice and this permission notice shall be 
 *  included in all copies or substantial portions of the Library.
 *
 *  If you modify the Library, you may copy and distribute your modified 
 *  version of the Library in object code or as an executable provided 
 *  that you also do one of the following:
 *
 *   Accompany the modified version of the Library with the complete 
 *   corresponding machine-readable source code for the modified version 
 *   of the Library; or,
 *
 *   Accompany the modified version of the Library with a written offer 
 *   for a complete machine-readable copy of the corresponding source 
 *   code of the modified version of the Library.
 *
 *
 * THE LIBRARY IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * LIBRARY OR THE USE OR OTHER DEALINGS IN THE LIBRARY.
 */

#ifndef MARS_SYSCALLS_H
#define MARS_SYSCALLS_H

#if defined(__cplusplus)
extern "C" {
#endif

#include <stdint.h>

uint64_t mars_get_mars_context_ea(void);
uint32_t mars_get_kernel_id(void);
uint16_t mars_get_workload_id(void);
uint64_t mars_get_workload_ea(void);
struct mars_workload_context *mars_get_workload_context(void);

void mars_init(void);
void mars_exit(void);
void mars_yield(void);
int mars_schedule(uint16_t workload_id, void *args, uint8_t priority);
int mars_wait(uint16_t workload_id);
int mars_try_wait(uint16_t workload_id);
int mars_signal_send(uint16_t workload_id);
void mars_signal_wait(void);
int mars_signal_try_wait(void);

#if defined(__cplusplus)
}
#endif

#endif
