/*
 * Copyright 2008 Sony Corporation of America
 *
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this Library and associated documentation files (the
 * "Library"), to deal in the Library without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Library, and to
 * permit persons to whom the Library is furnished to do so, subject to
 * the following conditions:
 *
 *  The above copyright notice and this permission notice shall be 
 *  included in all copies or substantial portions of the Library.
 *
 *  If you modify the Library, you may copy and distribute your modified 
 *  version of the Library in object code or as an executable provided 
 *  that you also do one of the following:
 *
 *   Accompany the modified version of the Library with the complete 
 *   corresponding machine-readable source code for the modified version 
 *   of the Library; or,
 *
 *   Accompany the modified version of the Library with a written offer 
 *   for a complete machine-readable copy of the corresponding source 
 *   code of the modified version of the Library.
 *
 *
 * THE LIBRARY IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * LIBRARY OR THE USE OR OTHER DEALINGS IN THE LIBRARY.
 */

#include "mars/mars_kernel.h"

void registers_save(void)
{
	/* push non-volatile registers on to the stack */
	asm volatile (
		"lqa	$75, process_stack;"

		"stqd	$80, -16($75);"
		"stqd	$81, -32($75);"
		"stqd	$82, -48($75);"
		"stqd	$83, -64($75);"
		"stqd	$84, -80($75);"
		"stqd	$85, -96($75);"
		"stqd	$86, -112($75);"
		"stqd	$87, -128($75);"
		"stqd	$88, -144($75);"
		"stqd	$89, -160($75);"
		"stqd	$90, -176($75);"
		"stqd	$91, -192($75);"
		"stqd	$92, -208($75);"
		"stqd	$93, -224($75);"
		"stqd	$94, -240($75);"
		"stqd	$95, -256($75);"
		"stqd	$96, -272($75);"
		"stqd	$97, -288($75);"
		"stqd	$98, -304($75);"
		"stqd	$99, -320($75);"
		"stqd	$100, -336($75);"
		"stqd	$101, -352($75);"
		"stqd	$102, -368($75);"
		"stqd	$103, -384($75);"
		"stqd	$104, -400($75);"
		"stqd	$105, -416($75);"
		"stqd	$106, -432($75);"
		"stqd	$107, -448($75);"
		"stqd	$108, -464($75);"
		"stqd	$109, -480($75);"
		"stqd	$110, -496($75);"
		"stqd	$111, -512($75);"
		"stqd	$112, -528($75);"
		"stqd	$113, -544($75);"
		"stqd	$114, -560($75);"
		"stqd	$115, -576($75);"
		"stqd	$116, -592($75);"
		"stqd	$117, -608($75);"
		"stqd	$118, -624($75);"
		"stqd	$119, -640($75);"
		"stqd	$120, -656($75);"
		"stqd	$121, -672($75);"
		"stqd	$122, -688($75);"
		"stqd	$123, -704($75);"
		"stqd	$124, -720($75);"
		"stqd	$125, -736($75);"
		"stqd	$126, -752($75);"
		"stqd	$127, -768($75);"
	);
}

void registers_restore(void)
{
	/* pop non-volatile registers from saved process stack */
	asm volatile (
		"lqa	$75, process_stack;"

		"lqd	$80, -16($75);"
		"lqd	$81, -32($75);"
		"lqd	$82, -48($75);"
		"lqd	$83, -64($75);"
		"lqd	$84, -80($75);"
		"lqd	$85, -96($75);"
		"lqd	$86, -112($75);"
		"lqd	$87, -128($75);"
		"lqd	$88, -144($75);"
		"lqd	$89, -160($75);"
		"lqd	$90, -176($75);"
		"lqd	$91, -192($75);"
		"lqd	$92, -208($75);"
		"lqd	$93, -224($75);"
		"lqd	$94, -240($75);"
		"lqd	$95, -256($75);"
		"lqd	$96, -272($75);"
		"lqd	$97, -288($75);"
		"lqd	$98, -304($75);"
		"lqd	$99, -320($75);"
		"lqd	$100, -336($75);"
		"lqd	$101, -352($75);"
		"lqd	$102, -368($75);"
		"lqd	$103, -384($75);"
		"lqd	$104, -400($75);"
		"lqd	$105, -416($75);"
		"lqd	$106, -432($75);"
		"lqd	$107, -448($75);"
		"lqd	$108, -464($75);"
		"lqd	$109, -480($75);"
		"lqd	$110, -496($75);"
		"lqd	$111, -512($75);"
		"lqd	$112, -528($75);"
		"lqd	$113, -544($75);"
		"lqd	$114, -560($75);"
		"lqd	$115, -576($75);"
		"lqd	$116, -592($75);"
		"lqd	$117, -608($75);"
		"lqd	$118, -624($75);"
		"lqd	$119, -640($75);"
		"lqd	$120, -656($75);"
		"lqd	$121, -672($75);"
		"lqd	$122, -688($75);"
		"lqd	$123, -704($75);"
		"lqd	$124, -720($75);"
		"lqd	$125, -736($75);"
		"lqd	$126, -752($75);"
		"lqd	$127, -768($75);"
	);
}
